(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "prop-types", "react", "@patternfly/react-styles/css/components/Drawer/drawer", "@patternfly/react-styles", "./Drawer"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("prop-types"), require("react"), require("@patternfly/react-styles/css/components/Drawer/drawer"), require("@patternfly/react-styles"), require("./Drawer"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.propTypes, global.react, global.drawer, global.reactStyles, global.Drawer);
    global.undefined = mod.exports;
  }
})(this, function (exports, _propTypes, _react, _drawer, _reactStyles, _Drawer) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.DrawerPanelContent = undefined;

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var React = _interopRequireWildcard(_react);

  var _drawer2 = _interopRequireDefault(_drawer);

  function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;
    var cache = new WeakMap();

    _getRequireWildcardCache = function () {
      return cache;
    };

    return cache;
  }

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }

    var cache = _getRequireWildcardCache();

    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }

    var newObj = {};

    if (obj != null) {
      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;

      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;

          if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }

    newObj.default = obj;

    if (cache) {
      cache.set(obj, newObj);
    }

    return newObj;
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  const DrawerPanelContent = exports.DrawerPanelContent = _ref => {
    let {
      className = '',
      children,
      hasBorder = false,
      width,
      widthOnLg,
      widthOnXl,
      widthOn2Xl
    } = _ref,
        props = _objectWithoutProperties(_ref, ["className", "children", "hasBorder", "width", "widthOnLg", "widthOnXl", "widthOn2Xl"]);

    return React.createElement(_Drawer.DrawerContext.Consumer, null, ({
      isExpanded
    }) => React.createElement("div", _extends({
      className: (0, _reactStyles.css)(_drawer2.default.drawerPanel, hasBorder && _drawer2.default.modifiers.border, width && _drawer2.default.modifiers[`width_${width}`], widthOnLg && _drawer2.default.modifiers[`width_${widthOnLg}OnLg`], widthOnXl && _drawer2.default.modifiers[`width_${widthOnXl}OnXl`], widthOn2Xl && _drawer2.default.modifiers[`width_${widthOn2Xl}On_2xl`], className),
      hidden: !isExpanded,
      "aria-hidden": !isExpanded,
      "aria-expanded": isExpanded
    }, props), children));
  };

  DrawerPanelContent.propTypes = {
    className: _propTypes2.default.string,
    children: _propTypes2.default.node,
    hasBorder: _propTypes2.default.bool,
    width: _propTypes2.default.oneOf([25, 33, 50, 66, 75, 100]),
    widthOnLg: _propTypes2.default.oneOf([25, 33, 50, 66, 75, 100]),
    widthOnXl: _propTypes2.default.oneOf([25, 33, 50, 66, 75, 100]),
    widthOn2Xl: _propTypes2.default.oneOf([25, 33, 50, 66, 75, 100])
  };
});
//# sourceMappingURL=DrawerPanelContent.js.map